﻿using System;
using System.Collections.Generic;
using System.Linq;
using ff14bot;
using ff14bot.Enums;
using ff14bot.Interfaces;
using ff14bot.Managers;
using ff14bot.Objects;
using System.Threading.Tasks;
using System.Threading;
using TreeSharp;
using ff14bot.Behavior;
using ff14bot.Helpers;
using Buddy.Coroutines;
using System.IO;

namespace Charta
{
    public class Charta : IBotPlugin
    {
        internal cLogger Logger { get; private set; }
        private Composite _coroutine;


        private Charta()
        {

        }

        #region Plugin Information

        public string Author
        {
            get { return " hueCannibal"; }
        }

        public string Name
        {
            get { return "Charta"; }
        }

        public string Description
        {
            get { return "Obtain maps from gathering nodes."; }
        }

        public Version Version
        {
            get { return new Version(0, 0, 1); }
        }


        public bool WantButton
        {
            get { return true; }
        }

        public string ButtonText
        {
            get { return "Charta"; }
        }

        public bool Equals(IBotPlugin other)
        {
            throw new NotImplementedException();
        }

        public void OnPulse()
        {
            try
            {
                if(!_coroutine.IsRunning)
                {
                    _coroutine.Start(null);
                }
            }
            catch(Exception e)
            {
                Logger.Write(LoggerType.Error, e.Message);
                throw;
            }
        }


        public void OnShutdown()
        {
        }

        public void OnDisabled()
        {
            TreeHooks.Instance.OnHooksCleared -= OnHooksCleared;
            TreeHooks.Instance.RemoveHook("TreeStart", _coroutine);
        }


        public void OnEnabled()
        {
            TreeHooks.Instance.AddHook("TreeStart", _coroutine);
            TreeHooks.Instance.OnHooksCleared += OnHooksCleared;
        }

        private void OnHooksCleared(object sender, EventArgs args)
        {
            TreeHooks.Instance.AddHook("TreeStart", _coroutine);
        }
        #endregion

        public void OnButtonPress()
        {
        }

        public void OnInitialize()
        {
            if (Logger == null)
                Logger = new cLogger();

            _coroutine = new Decorator(c => GatheringManager.WindowOpen,
                                       new ActionRunCoroutine(r => ObtainMap()));
        }

        public async Task<bool> ObtainMap()
        {
            foreach(var item in GatheringManager.GatheringWindowItems)
            {
                if(item.ItemData.EnglishName.EndsWith("Map"))
                {
                    await Coroutine.Wait(700, () => item.GatherItem());
                    Logger.Write(string.Format("Attempting to obtain {0}", item.ItemData.EnglishName));
                }
            }

            return false;
        }
    }
}